﻿using System;

namespace CalculatePrice
{
    class Program
    {
        static void Main(string[] args)
        {
            const double BIG_GROUP_DISCOUNT = 0.15;
            const double GROUP_DISCOUNT = 0.10;

            string ageStr;
            int age;
            string studentCardStr;
            bool studentCard;

            double basePrice = 100;
            double totalPrice = 0;

            string language;
            string greeting;
            
          //string moreStr;
          //bool more = true;

            int count = 0;

/*
            while (more){
            System.Console.Write("Alder: ");
            ageStr = Console.ReadLine();
            age = Convert.ToInt32(ageStr);

            if (age > 16){
                System.Console.Write("Studiekort j/n:");
                studentCardStr = Console.ReadLine();

                if (studentCardStr.ToLower()=="j") studentCard=true;
                else studentCard=false;
            } else studentCard=false;

            double price = CalculatePrice(basePrice, age, studentCard);
            totalPrice += price;
            count++;

            System.Console.WriteLine($"Alder: {age} Studiekort: {studentCard} pris: {price}");

            System.Console.Write("Flere gruppemedlemmer? j/n:");
            moreStr = Console.ReadLine();
            if (moreStr.ToLower()=="n") more=false;

            }
*/
            System.Console.Write("Language: ");
            language = Console.ReadLine();

            System.Console.Write("Antal gruppemedlemmer: ");
            count = Convert.ToInt32(Console.ReadLine());

            for (int i = count; i > 0; i--)
            {
                System.Console.Write("Alder: ");
                ageStr = Console.ReadLine();
                age = Convert.ToInt32(ageStr);

                if (age > 16){
                    System.Console.Write("Studiekort j/n:");
                    studentCardStr = Console.ReadLine();

                    if (studentCardStr.ToLower()=="j") studentCard=true;
                    else studentCard=false;
                } else studentCard=false;

                double price = CalculatePrice(basePrice, age, studentCard);
                totalPrice += price;
               
                System.Console.WriteLine($"Alder: {age} Studiekort: {studentCard} pris: {price}");
         }


            if (count >= 20) totalPrice = totalPrice * (1 - BIG_GROUP_DISCOUNT);
            else if (count >= 10) totalPrice = totalPrice * (1 - GROUP_DISCOUNT);
           
            System.Console.WriteLine($"Gruppestørrelse: {count} Samlet pris er: {totalPrice}");
           
           
            switch (language.ToUpper()){
                case "UK" : greeting="Good day"; 
                            break;
                case "DK" : greeting="God dag"; 
                            break;
                case "D" :  greeting="Guten tag";
                            break;
                default :   greeting="Aloha";
                            break;
            }
            System.Console.WriteLine(greeting);
/*
            System.Console.WriteLine("alder 2år: " + CalculatePrice(100, 2, false));
            System.Console.WriteLine("alder 12år: " + CalculatePrice(100, 12, false));
            System.Console.WriteLine("alder 20år ikke studerende: " + CalculatePrice(100, 20, false));
            System.Console.WriteLine("alder 20år studerende: " + CalculatePrice(100, 20, true));
            System.Console.WriteLine("alder 70år: " + CalculatePrice(100, 70, false));
*/            
        }

        private static double CalculatePrice(double basePrice, int age, bool student)
        {
            const double AGE_CHILD_DISCOUNT = 0.5; //børnerabat
            const double AGE_PENSIONER_DISCOUNT = 0.4; //pensionist rabat
            const double STUDENT_DISCOUNT = 0.2; //studierabat
            const double LOW_SESSON_DISCOUNT = 0.2; //lavsesson
            const double HIGH_SESSON_CHARGE = 0.2; //Tillæg for højsesson
            const double HOUR_DISCOUNT = 0.1; //time rabat
            const double HOUR_CHARGE = 0.1; //time tillæg

            double price = basePrice;
            int month = DateTime.Now.Month;
            int hour = DateTime.Now.Hour;
            
            //Alderrabatter
            if (age <= 2) return 0; // barn under 3
            if (age <= 12) price = price*(1 - AGE_CHILD_DISCOUNT); //børn under 13
            if (age > 67) price = price*(1 - AGE_PENSIONER_DISCOUNT); // pensionist rabat for 68+

            //Studierabat
            if (student) price = price*(1 - STUDENT_DISCOUNT);

            //Sesson tillæg/rabat
            if (month==1 || month==2) price = price*(1 - LOW_SESSON_DISCOUNT);
            if (month>=5 && month<=8) price = price*(1 + HIGH_SESSON_CHARGE);

            //Time tillæg/rabat
            if (hour>=8 && hour<10) price = price*(1 - HOUR_DISCOUNT);
            if (hour>=15 && hour<20) price = price*(1 + HOUR_CHARGE); 
            return price;
        }
    }
}
